#version 120

uniform sampler2D       Texture;
uniform sampler2D       Scene;
uniform sampler2D       Dirt;
uniform vec4            Param1; // (SunPosX, SunPosY, 1.0/fbo.width, 0.5/FlareTexture.width)
uniform vec4            Param2; // (Radius, Stride, Bright, Scale)
uniform float			screenRatio; // GLFrame.getHeight() / GLFrame.getWidth()

const float Sexposure = 0.67;
const float Sdecay = 0.996;
const float Sdensity = 0.8;
const float Sweight = 0.02;

uniform sampler2D firstPass;
const int NUM_SAMPLES = 30 ;
	
	
	void main() {
	
		float newRadius = Param2.x * 2;
	
		vec2 deltaTextCoord = vec2( gl_TexCoord[0].st - Param1.xy );
		vec2 textCoo = gl_TexCoord[0].st;
		
		deltaTextCoord *= 1.0 / float(NUM_SAMPLES) * Sdensity;
		
		float illuminationDecay = 1.0;
		
		vec4 fragCol = vec4(0.0,0.0,0.0,0.0);
		for(int i=0; i < NUM_SAMPLES ; i++) {
		
			textCoo -= deltaTextCoord;
			vec4 sample = texture2D(firstPass, textCoo );
			
			sample *= illuminationDecay * Sweight;
			fragCol += sample;
			illuminationDecay *= Sdecay;
			
		}
		
		float brightness	= 0.25 * 0.25 + 1;
		float radius		= 1.4 + brightness * 0.2;
		float invRadius 	= 1.0/radius;
		
		vec3 orange			= vec3( 0.8, 0.65, 0.3 );
		vec3 orangeRed		= vec3( 0.8, 0.35, 0.1 );
		float time		=  0.1;
		float aspect	= screenRatio;
		vec2 uv			= gl_FragCoord.xy / vec2(3840, 2160);
		vec2 p 			= -0.5 + uv;
		p.x *= aspect;
		
		float dist		= length(p);
		
		vec2 sp = -1.0 + 2.0 * uv;
		sp.x *= aspect;
		sp *= ( 2.0 - (brightness / 2) );
		float r = dot(sp,sp);
		float f = (1.0-sqrt(abs(1.0-r)))/(r) + brightness * 0.5;
		
		float starGlow	= min( max( 1.0 - dist * ( 1.0 - brightness ), 0.0 ), 1.0 ) * 1.3;
		vec3 starCol	= vec3(( 0.75 + brightness * 0.3 ) * orange ) * orange + starGlow * orangeRed;
		
		vec4 starCol4 = vec4(starCol + vec3(0.2, 0., 0.), 1.0);
		
		fragCol *= 1.1;
		
		gl_FragColor = (fragCol*(starCol4));//+dirt; 
	}